#include <stdio.h>
#include <stdlib.h>

double *dmalloc(unsigned long);

main(){
   
  char filename[] = "test.dat";
  int i,j,n=10,m=5;
  double *ans;
  void domat(char *,int,int,double *,void(*thefun)(int,int,double*,double*));
  void rowmean(int, int,double*,double*);
  void colmean(int, int,double*,double*);
  void colmax(int, int, double*,double*);
 
  ans = dmalloc(n); 
  domat(filename,n,m,ans,rowmean);
  printf("Rowmeans:\n");
  for(i=0;i<n;i++)printf("i=%d %g\n",i,ans[i]);
  printf("\n");

  free(ans);
  ans = dmalloc(m);
  domat(filename,n,m,ans,colmean);
  printf("Colmeans:\n");
  for(i=0;i<m;i++)printf("i=%d %g\n",i,ans[i]);
  printf("\n");

  free(ans);
  ans = dmalloc(m);
  domat(filename,n,m,ans,colmax);
  printf("Colmaxs:\n");
  for(i=0;i<m;i++)printf("i=%d %g\n",i,ans[i]);

}

void domat(char *filename,int n,int m,double *ans,void(*thefun)(int,int,double*,double*))
{
   FILE *f;
   int i,j;
   double *x;

   f = fopen(filename,"r");
   if(f == NULL){
     fprintf(stderr,"Couldn't open %s for reading\n",filename);
     exit(1);
     }

   x = dmalloc(n * m);

   for(i=0;i<n;i++)
      for(j=0;j<m;j++)
         fscanf(f,"%lf",x + i * n + j);
 
   (*thefun)(n,m,x,ans);
}

void rowmean(int n,int m,double *x,double *result)
{
   int i,j;
   for(i=0;i<n;i++){
      result[i] = 0;
      for(j=0;j<m;j++)result[i] += x[j + i * n];
      result[i] /= (double)m;
      }
}

void colmean(int n,int m,double *x,double *result)
{
   int i,j;
   for(j=0;j<m;j++){
      result[j] = 0;
      for(i=0;i<n;i++)result[j] += x[j + i * n];
      result[j] /= (double)n;
      }
   }

void colmax(int n,int m,double *x,double *result)
{
   int i,j;
   for(j=0;j<m;j++){
      result[j] = -1e-20;
      for(i=0;i<n;i++)if(x[j + i * n] > result[j])result[j] = x[j + i * n];
      }
}
